require "import"
import "android.content.Context"
import "android.content.Intent"
import "android.net.Uri"
import "android.view.View"
import "android.widget.EditText"
import "android.widget.GridView"
import "com.androlua.LuaDialog"
import "com.androlua.SingleLineAdapter"
import "java.lang.String"

local Symbol = {}
dir = package.searchpath("main", package.path):match("(.*)main.lua")
local path = dir .. "/data"

local function readSymbol(t, path)
    local file = io.open(path, "r")
    if file then
        for line in file:lines() do
            s = string.gsub(line, '\\n', '\n')
            s = s == "\\\\" and "\\" or s
            table.insert(t, s)
        end
        file:close()
    end
end

local function writeSymbol(t, path)
    local file = io.open(path, 'w')
    if file then
        for _, v in ipairs(t) do
            v = v == "\\" and "\\\\" or v
            file:write(string.gsub(v, '\n', '\\n') .. '\n')
        end
        file:close()
    end
end

local function moveItem(t, k, itemKey)
    local s = t[k + 1]
    if itemKey == 4 then
        table.insert(t, 1, s)
        table.remove(t, k + 2)
    elseif itemKey == 5 then
        table.remove(t, k + 1)
        table.insert(t, s)
    end
end

local function removeItem(t, k)
    table.remove(t, k)
end

local edit = loadlayout {
    EditText;
    hint = "Bạn có thể nhập một cụm từ hoặc ký tự trên nhiều dòng"
}
local et = LuaDialog()
et.setTitle("Thêm vào")
et.setView(edit)
et.setButton("OK", function()
    if edit.text ~= '' then
        local confirmDialog = LuaDialog()
        confirmDialog.setTitle("Xác nhận")
        confirmDialog.setMessage("Bạn có muốn lưu \"" .. edit.text .. "\" vào danh sách biểu tượng cảm xúc hay không?")
        confirmDialog.setPositiveButton("Lưu", function()
            table.insert(Symbol, edit.text)
            edit.text = ''
            writeSymbol(Symbol, path)
service.asyncSpeak("đã lưu biểu tượng cảm xúc thành công")
            grid.adapter = SingleLineAdapter(service, String(Symbol))
        end)
        confirmDialog.setNegativeButton("Huỷ", nil)
        confirmDialog.show()
    else
service.asyncSpeak(" văn bản không có nội dung")
  dlg.show()
    end
end)
et.setNegativeButton("Huỷ", nil)
local readme = LuaDialog(service)
readme.setTitle("Mô tả")
readme.setMessage(    "Xin chào. Đây là tiện ích biểu tượng cảm xúc. Tôi đã lưu các danh mục biểu tượng cảm xúc. Nếu bạn muốn thêm nhiều biểu tượng cảm xúc khác, hãy nhấp vào Thêm rồi nhập biểu tượng hoặc biểu tượng cảm xúc. Tham gia kênh Telegram của tôi")
readme.setButton2("Kênh tiện ích chức năng và công cụ", function()
    local intent = Intent(Intent.ACTION_VIEW, Uri.parse("https://t.me/tkmrcccmjsr"))
    service.startActivity(intent)
end)
readme.setButton("Thoát", function()
    dlg.show()
end)

local menuItem = {
    "Sao chép biểu tượng cảm xúc",
    "Lưu biểu tượng cảm xúc vào yêu thích",
    "Chia sẻ biểu tượng cảm xúc",
    "Xóa biểu tượng cảm xúc",
    "Di chuyển biểu tượng cảm xúc lên đầu",
    "Di chuyển biểu tượng cảm xúc xuống cuối",
    "Chỉnh sửa biểu tượng cảm xúc",
    "Thoát",
}

local menuDlg = LuaDialog(service)
menuDlg.setItems(menuItem)

layout = {
    GridView,
    id = "grid",
    numColumns = 6,
    layout_width = "fill",
    layout_height = "fill",
}

dlg = LuaDialog(service)
dlg.View = loadlayout(layout)
readSymbol(Symbol, path)
grid.adapter = SingleLineAdapter(service, String(Symbol))
dlg.setButton("Thoát")
dlg.setButton2("Thêm", function(v)
    et.show()
end)
dlg.setButton3("Mô tả", function(v)
    readme.show()
end)
dlg.setCancelable(false)

dlg.show()
grid.onItemClick = function(l, v)
    dlg.dismiss()
    service.pasteText(node, v.text)
    service.speak(v.text)
    return true
end

grid.onItemLongClick = function(l, v, p, i)
    dlg.dismiss()
    vibrator = this.getSystemService(Context.VIBRATOR_SERVICE)
    vibrator.vibrate(long{100, 30}, -1)
    menuDlg.show()
    menuDlg.onItemClick = function(_, _, itemKey)
        menuDlg.dismiss()
        if itemKey == 0 then
            service.copy(Symbol[i + 1])
service.asyncSpeak(" đã sao chép biểu tượng cảm xúc thành công")
        elseif itemKey == 1 then
            service.addFavorites(Symbol[i + 1])
service.asyncSpeak(" đã lưu biểu tượng cảm xúc vào yêu thích")
        elseif itemKey == 2 then
            local shareIntent = Intent(Intent.ACTION_SEND)
            shareIntent.setType("text/plain")
            shareIntent.putExtra(Intent.EXTRA_TEXT, Symbol[i + 1])
            service.startActivity(Intent.createChooser(shareIntent, "Chia sẻ biểu tượng cảm xúc"))
        elseif itemKey == 3 then
            LuaDialog(service)
                .setTitle("Xoá biểu tượng cảm xúc")
                .setMessage("Bạn có chắc muốn xoá biểu tượng cảm xúc này?")
                .setButton("OK", function()
                    removeItem(Symbol, i + 1)
service.asyncSpeak("Đã xóa biểu tượng cảm xúc")
                    writeSymbol(Symbol, path)
                    grid.adapter = SingleLineAdapter(service, String(Symbol))
                    dlg.show()
                end)
                .setButton2("Hủy", function()
                    menuDlg.show()
                end)
                .show()
        elseif itemKey == 4 then
            LuaDialog(service)
                .setTitle("Di chuyển lên đầu")
                .setMessage("Bạn có chắc muốn di chuyển biểu tượng cảm xúc này lên đầu?")
                .setButton("OK", function()
                    moveItem(Symbol, i, itemKey)
service.asyncSpeak("Đã di chuyển biểu tượng cảm xúc lên đầu")
                    writeSymbol(Symbol, path)
                    grid.adapter = SingleLineAdapter(service, String(Symbol))
                    dlg.show()
                end)
                .setButton2("Hủy", function()
                    menuDlg.show()
                end)
                .show()
        elseif itemKey == 5 then
            LuaDialog(service)
                .setTitle("Di chuyển xuống cuối")
                .setMessage("Bạn có chắc muốn di chuyển biểu tượng cảm xúc này xuống cuối?")
                .setButton("OK", function()
                    moveItem(Symbol, i, itemKey)
service.asyncSpeak("Đã di chuyển biểu tượng cảm xúc xuống cuối")
                    writeSymbol(Symbol, path)
                    grid.adapter = SingleLineAdapter(service, String(Symbol))
                    dlg.show()
                end)
                .setButton2("Hủy", function()
                    menuDlg.show()
                end)
                .show()
elseif itemKey == 6 then
    local editDialog = LuaDialog(service)
    editDialog.setTitle("Chỉnh sửa biểu tượng cảm xúc")
    editDialog.setView(EditText(service).setText(Symbol[i + 1]))
    editDialog.setPositiveButton("Lưu", function()
        local newText = editDialog.getView().getText().toString()
        table.remove(Symbol, i + 1)
        table.insert(Symbol, i + 1, newText)
        writeSymbol(Symbol, path)
        grid.adapter = SingleLineAdapter(service, String(Symbol))
        dlg.show()
        service.asyncSpeak("Đã chỉnh sửa biểu tượng cảm xúc")
    end)
    editDialog.setNegativeButton("Huỷ", nil)
    editDialog.show()
        elseif itemKey == 7 then
            dlg.show()
        end
    end
end
